<template>
  <a-modal
    v-model:visible="props.visible"
    :title="props.roleId ? '编辑' : '新增'"
    width="500px"
    @cancel="dialogClose"
  >
    <a-form
      class="ls-form"
      ref="formRef"
      :model="formData"
      :label-col="{ style: { width: '85px' } }"
    >
      <a-form-item
        label="角色名称"
        name="name"
        :rules="{ required: true, message: '请输入角色名称', trigger: 'blur' }"
      >
        <a-input v-model:value="formData.name" placeholder="请输入角色名称" allow-clear />
      </a-form-item>
      <a-form-item
        label="角色编码"
        name="code"
        :rules="{ required: true, message: '请输入角色编码', trigger: 'blur' }"
      >
        <a-input v-model:value="formData.code" placeholder="请输入角色编码" allow-clear />
      </a-form-item>
      <a-form-item label="排序" name="sort">
        <a-input-number v-model:value="formData.sort" />
      </a-form-item>
      <a-form-item label="备注" name="note">
        <a-textarea v-model:value="formData.note" placeholder="请输入备注" allow-clear />
      </a-form-item>
    </a-form>
    <template #footer>
      <span class="dialog-footer">
        <a-button @click="dialogClose">取消</a-button>
        <a-button :loading="subLoading" type="primary" @click="submit"> 确定 </a-button>
      </span>
    </template>
  </a-modal>
</template>
<script lang="ts" setup>
  import type { FormInstance } from 'ant-design-vue';
  import { getRoleDetail, roleAdd, roleUpdate } from '@/api/system/role';
  import { onMounted, reactive, shallowRef } from 'vue';
  import { message } from 'ant-design-vue';
  import { useLockFn } from '@/utils/useLockFn';

  /**
   * 定义参数变量
   */
  const emit = defineEmits(['success', 'update:visible']);
  const formRef = shallowRef<FormInstance>();

  /**
   * 定义表单参数
   */
  const formData = reactive({
    id: '',
    name: '',
    code: '',
    sort: 0,
    note: '',
  });

  /**
   * 定义接收的参数
   */
  const props = defineProps({
    visible: {
      type: Boolean,
      required: true,
      default: false,
    },
    roleId: {
      type: Number,
      required: true,
      default: 0,
    },
  });

  /**
   * 执行提交表单
   */
  const handleSubmit = async () => {
    await formRef.value?.validate();
    props.roleId ? await roleUpdate(formData) : await roleAdd(formData);
    message.success('操作成功');
    emit('update:visible', false);
    emit('success');
  };

  /**
   * 关闭窗体
   */
  const dialogClose = () => {
    emit('update:visible', false);
  };

  const { isLock: subLoading, lockFn: submit } = useLockFn(handleSubmit);

  /**
   * 设置表单数据
   */
  const setFormData = async () => {
    const data = await getRoleDetail(props.roleId);
    for (const key in formData) {
      if (data[key] != null && data[key] != undefined) {
        //@ts-ignore
        formData[key] = data[key];
      }
    }
  };

  /**
   * 钩子函数
   */
  onMounted(() => {
    if (props.roleId) {
      setFormData();
    }
  });
</script>
